# @backstage/plugin-events-backend-module-github

## 0.0.0-nightly-20240506021511

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.0.0-nightly-20240506021511
  - @backstage/plugin-events-node@0.0.0-nightly-20240506021511

## 0.2.4-next.1

### Patch Changes

- Updated dependencies
  - @backstage/plugin-events-node@0.3.4-next.1
  - @backstage/backend-plugin-api@0.6.18-next.1

## 0.2.4-next.0

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.18-next.0
  - @backstage/config@1.2.0
  - @backstage/plugin-events-node@0.3.4-next.0

## 0.2.3

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.17
  - @backstage/plugin-events-node@0.3.3
  - @backstage/config@1.2.0

## 0.2.3-next.1

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.17-next.1
  - @backstage/plugin-events-node@0.3.3-next.1
  - @backstage/config@1.2.0

## 0.2.3-next.0

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.17-next.0
  - @backstage/config@1.2.0
  - @backstage/plugin-events-node@0.3.3-next.0

## 0.2.2

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.16
  - @backstage/plugin-events-node@0.3.2
  - @backstage/config@1.2.0

## 0.2.1

### Patch Changes

- Updated dependencies
  - @backstage/plugin-events-node@0.3.1
  - @backstage/backend-plugin-api@0.6.15
  - @backstage/config@1.2.0

## 0.2.0

### Minor Changes

- eff3ca9: BREAKING CHANGE: Migrate `EventRouter` implementations from `EventBroker` to `EventsService`.

  `EventRouter` uses the new `EventsService` instead of the `EventBroker` now,
  causing a breaking change to its signature.

  All of its extensions and implementations got adjusted accordingly.
  (`SubTopicEventRouter`, `AzureDevOpsEventRouter`, `BitbucketCloudEventRouter`,
  `GerritEventRouter`, `GithubEventRouter`, `GitlabEventRouter`)

  Required adjustments were made to all backend modules for the new backend system,
  now also making use of the `eventsServiceRef` instead of the `eventsExtensionPoint`.

  **Migration:**

  Example for implementations of `SubTopicEventRouter`:

  ```diff
    import {
      EventParams,
  +   EventsService,
      SubTopicEventRouter,
    } from '@backstage/plugin-events-node';

    export class GithubEventRouter extends SubTopicEventRouter {
  -   constructor() {
  -     super('github');
  +   constructor(options: { events: EventsService }) {
  +     super({
  +       events: options.events,
  +       topic: 'github',
  +     });
      }

  +   protected getSubscriberId(): string {
  +     return 'GithubEventRouter';
  +   }
  +
      // ...
    }
  ```

  Example for a direct extension of `EventRouter`:

  ```diff
    class MyEventRouter extends EventRouter {
  -   constructor(/* ... */) {
  +   constructor(options: {
  +     events: EventsService;
  +     // ...
  +   }) {
  -     super();
        // ...
  +     super({
  +       events: options.events,
  +       topics: topics,
  +     });
      }
  +
  +   protected getSubscriberId(): string {
  +     return 'MyEventRouter';
  +   }
  -
  -   supportsEventTopics(): string[] {
  -     return this.topics;
  -   }
    }
  ```

### Patch Changes

- Updated dependencies
  - @backstage/plugin-events-node@0.3.0
  - @backstage/config@1.2.0
  - @backstage/backend-plugin-api@0.6.14

## 0.2.0-next.2

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.14-next.2
  - @backstage/config@1.2.0-next.1
  - @backstage/plugin-events-node@0.3.0-next.2

## 0.2.0-next.1

### Patch Changes

- Updated dependencies
  - @backstage/config@1.2.0-next.1
  - @backstage/backend-plugin-api@0.6.14-next.1
  - @backstage/plugin-events-node@0.3.0-next.1

## 0.2.0-next.0

### Minor Changes

- eff3ca9: BREAKING CHANGE: Migrate `EventRouter` implementations from `EventBroker` to `EventsService`.

  `EventRouter` uses the new `EventsService` instead of the `EventBroker` now,
  causing a breaking change to its signature.

  All of its extensions and implementations got adjusted accordingly.
  (`SubTopicEventRouter`, `AzureDevOpsEventRouter`, `BitbucketCloudEventRouter`,
  `GerritEventRouter`, `GithubEventRouter`, `GitlabEventRouter`)

  Required adjustments were made to all backend modules for the new backend system,
  now also making use of the `eventsServiceRef` instead of the `eventsExtensionPoint`.

  **Migration:**

  Example for implementations of `SubTopicEventRouter`:

  ```diff
    import {
      EventParams,
  +   EventsService,
      SubTopicEventRouter,
    } from '@backstage/plugin-events-node';

    export class GithubEventRouter extends SubTopicEventRouter {
  -   constructor() {
  -     super('github');
  +   constructor(options: { events: EventsService }) {
  +     super({
  +       events: options.events,
  +       topic: 'github',
  +     });
      }

  +   protected getSubscriberId(): string {
  +     return 'GithubEventRouter';
  +   }
  +
      // ...
    }
  ```

  Example for a direct extension of `EventRouter`:

  ```diff
    class MyEventRouter extends EventRouter {
  -   constructor(/* ... */) {
  +   constructor(options: {
  +     events: EventsService;
  +     // ...
  +   }) {
  -     super();
        // ...
  +     super({
  +       events: options.events,
  +       topics: topics,
  +     });
      }
  +
  +   protected getSubscriberId(): string {
  +     return 'MyEventRouter';
  +   }
  -
  -   supportsEventTopics(): string[] {
  -     return this.topics;
  -   }
    }
  ```

### Patch Changes

- Updated dependencies
  - @backstage/plugin-events-node@0.3.0-next.0
  - @backstage/backend-plugin-api@0.6.13-next.0
  - @backstage/config@1.1.2-next.0

## 0.1.20

### Patch Changes

- 9aac2b0: Use `--cwd` as the first `yarn` argument
- Updated dependencies
  - @backstage/backend-plugin-api@0.6.10
  - @backstage/config@1.1.1
  - @backstage/plugin-events-node@0.2.19

## 0.1.20-next.3

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.10-next.3
  - @backstage/config@1.1.1
  - @backstage/plugin-events-node@0.2.19-next.3

## 0.1.20-next.2

### Patch Changes

- 9aac2b0: Use `--cwd` as the first `yarn` argument
- Updated dependencies
  - @backstage/backend-plugin-api@0.6.10-next.2
  - @backstage/plugin-events-node@0.2.19-next.2
  - @backstage/config@1.1.1

## 0.1.20-next.1

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.10-next.1
  - @backstage/config@1.1.1
  - @backstage/plugin-events-node@0.2.19-next.1

## 0.1.20-next.0

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.10-next.0
  - @backstage/config@1.1.1
  - @backstage/plugin-events-node@0.2.19-next.0

## 0.1.19

### Patch Changes

- 4016f21: Remove some unused dependencies
- Updated dependencies
  - @backstage/backend-plugin-api@0.6.9
  - @backstage/config@1.1.1
  - @backstage/plugin-events-node@0.2.18

## 0.1.19-next.2

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.9-next.2
  - @backstage/plugin-events-node@0.2.18-next.2

## 0.1.19-next.1

### Patch Changes

- Updated dependencies
  - @backstage/config@1.1.1
  - @backstage/backend-plugin-api@0.6.9-next.1
  - @backstage/plugin-events-node@0.2.18-next.1

## 0.1.19-next.0

### Patch Changes

- 4016f21: Remove some unused dependencies
- Updated dependencies
  - @backstage/backend-plugin-api@0.6.9-next.0
  - @backstage/config@1.1.1
  - @backstage/plugin-events-node@0.2.18-next.0

## 0.1.18

### Patch Changes

- cc4228e: Switched module ID to use kebab-case.
- Updated dependencies
  - @backstage/backend-plugin-api@0.6.8
  - @backstage/config@1.1.1
  - @backstage/plugin-events-node@0.2.17

## 0.1.18-next.3

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.8-next.3
  - @backstage/config@1.1.1
  - @backstage/plugin-events-node@0.2.17-next.3

## 0.1.18-next.2

### Patch Changes

- cc4228e: Switched module ID to use kebab-case.
- Updated dependencies
  - @backstage/backend-plugin-api@0.6.8-next.2
  - @backstage/config@1.1.1
  - @backstage/plugin-events-node@0.2.17-next.2

## 0.1.18-next.1

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.8-next.1
  - @backstage/config@1.1.1
  - @backstage/plugin-events-node@0.2.17-next.1

## 0.1.18-next.0

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.8-next.0
  - @backstage/config@1.1.1
  - @backstage/plugin-events-node@0.2.17-next.0

## 0.1.17

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.7
  - @backstage/config@1.1.1
  - @backstage/plugin-events-node@0.2.16

## 0.1.17-next.2

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.7-next.2
  - @backstage/plugin-events-node@0.2.16-next.2

## 0.1.17-next.1

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.7-next.1
  - @backstage/config@1.1.1
  - @backstage/plugin-events-node@0.2.16-next.1

## 0.1.17-next.0

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.7-next.0
  - @backstage/config@1.1.1
  - @backstage/plugin-events-node@0.2.16-next.0

## 0.1.16

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.6
  - @backstage/config@1.1.1
  - @backstage/plugin-events-node@0.2.15

## 0.1.16-next.2

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.6-next.2
  - @backstage/config@1.1.1-next.0
  - @backstage/plugin-events-node@0.2.15-next.2

## 0.1.15-next.1

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.5-next.1
  - @backstage/config@1.1.0
  - @backstage/plugin-events-node@0.2.14-next.1

## 0.1.15-next.0

### Patch Changes

- Updated dependencies
  - @backstage/config@1.1.0
  - @backstage/backend-plugin-api@0.6.5-next.0
  - @backstage/plugin-events-node@0.2.14-next.0

## 0.1.13

### Patch Changes

- Updated dependencies
  - @backstage/config@1.1.0
  - @backstage/backend-plugin-api@0.6.3
  - @backstage/plugin-events-node@0.2.12

## 0.1.13-next.3

### Patch Changes

- Updated dependencies
  - @backstage/config@1.1.0-next.2
  - @backstage/backend-plugin-api@0.6.3-next.3
  - @backstage/plugin-events-node@0.2.12-next.3

## 0.1.13-next.2

### Patch Changes

- Updated dependencies
  - @backstage/config@1.1.0-next.1
  - @backstage/backend-plugin-api@0.6.3-next.2
  - @backstage/plugin-events-node@0.2.12-next.2

## 0.1.13-next.1

### Patch Changes

- Updated dependencies
  - @backstage/config@1.1.0-next.0
  - @backstage/backend-plugin-api@0.6.3-next.1
  - @backstage/plugin-events-node@0.2.12-next.1

## 0.1.12-next.0

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.2-next.0
  - @backstage/config@1.0.8
  - @backstage/plugin-events-node@0.2.11-next.0

## 0.1.10

### Patch Changes

- 629cbd194a87: Use `coreServices.rootConfig` instead of `coreService.config`
- 12a8c94eda8d: Add package repository and homepage metadata
- Updated dependencies
  - @backstage/backend-plugin-api@0.6.0
  - @backstage/plugin-events-node@0.2.9
  - @backstage/config@1.0.8

## 0.1.10-next.2

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.6.0-next.2
  - @backstage/plugin-events-node@0.2.9-next.2

## 0.1.10-next.1

### Patch Changes

- 629cbd194a87: Use `coreServices.rootConfig` instead of `coreService.config`
- 12a8c94eda8d: Add package repository and homepage metadata
- Updated dependencies
  - @backstage/plugin-events-node@0.2.9-next.1
  - @backstage/backend-plugin-api@0.6.0-next.1
  - @backstage/config@1.0.8

## 0.1.10-next.0

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.5.5-next.0
  - @backstage/config@1.0.8
  - @backstage/plugin-events-node@0.2.9-next.0

## 0.1.9

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.5.4
  - @backstage/config@1.0.8
  - @backstage/plugin-events-node@0.2.8

## 0.1.9-next.0

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.5.4-next.0
  - @backstage/config@1.0.8
  - @backstage/plugin-events-node@0.2.8-next.0

## 0.1.8

### Patch Changes

- 807416a9ed39: fix Installation documentation
- Updated dependencies
  - @backstage/backend-plugin-api@0.5.3
  - @backstage/config@1.0.8
  - @backstage/plugin-events-node@0.2.7

## 0.1.8-next.2

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.5.3-next.2
  - @backstage/config@1.0.7
  - @backstage/plugin-events-node@0.2.7-next.2

## 0.1.8-next.1

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.5.3-next.1
  - @backstage/plugin-events-node@0.2.7-next.1
  - @backstage/config@1.0.7

## 0.1.8-next.0

### Patch Changes

- Updated dependencies
  - @backstage/config@1.0.7
  - @backstage/backend-plugin-api@0.5.3-next.0
  - @backstage/plugin-events-node@0.2.7-next.0

## 0.1.7

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.5.2
  - @backstage/config@1.0.7
  - @backstage/plugin-events-node@0.2.6

## 0.1.7-next.1

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.5.2-next.1
  - @backstage/config@1.0.7
  - @backstage/plugin-events-node@0.2.6-next.1

## 0.1.7-next.0

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.5.2-next.0
  - @backstage/config@1.0.7
  - @backstage/plugin-events-node@0.2.6-next.0

## 0.1.6

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.5.1
  - @backstage/config@1.0.7
  - @backstage/plugin-events-node@0.2.5

## 0.1.6-next.2

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.5.1-next.2
  - @backstage/config@1.0.7
  - @backstage/plugin-events-node@0.2.5-next.2

## 0.1.6-next.1

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.5.1-next.1
  - @backstage/config@1.0.7
  - @backstage/plugin-events-node@0.2.5-next.1

## 0.1.6-next.0

### Patch Changes

- Updated dependencies
  - @backstage/config@1.0.7
  - @backstage/backend-plugin-api@0.5.1-next.0
  - @backstage/plugin-events-node@0.2.5-next.0

## 0.1.5

### Patch Changes

- a5de745ac17: Renamed `githubEventRouterEventsModule` to `eventsModuleGithubEventRouter` and `githubWebhookEventsModule` to `eventsModuleGithubWebhook`, to match the [recommended naming patterns](https://backstage.io/docs/backend-system/architecture/naming-patterns).
- 928a12a9b3e: Internal refactor of `/alpha` exports.
- Updated dependencies
  - @backstage/backend-plugin-api@0.5.0
  - @backstage/plugin-events-node@0.2.4
  - @backstage/config@1.0.7

## 0.1.5-next.2

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.4.1-next.2
  - @backstage/plugin-events-node@0.2.4-next.2
  - @backstage/config@1.0.7-next.0

## 0.1.5-next.1

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.4.1-next.1
  - @backstage/config@1.0.7-next.0
  - @backstage/plugin-events-node@0.2.4-next.1

## 0.1.5-next.0

### Patch Changes

- 928a12a9b3: Internal refactor of `/alpha` exports.
- Updated dependencies
  - @backstage/backend-plugin-api@0.4.1-next.0
  - @backstage/plugin-events-node@0.2.4-next.0
  - @backstage/config@1.0.6

## 0.1.4

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.4.0
  - @backstage/plugin-events-node@0.2.3
  - @backstage/config@1.0.6

## 0.1.4-next.2

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.4.0-next.2
  - @backstage/plugin-events-node@0.2.3-next.2
  - @backstage/config@1.0.6

## 0.1.4-next.1

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.3.2-next.1
  - @backstage/config@1.0.6
  - @backstage/plugin-events-node@0.2.3-next.1

## 0.1.4-next.0

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.3.2-next.0
  - @backstage/plugin-events-node@0.2.3-next.0

## 0.1.2

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.3.0
  - @backstage/config@1.0.6
  - @backstage/plugin-events-node@0.2.1

## 0.1.2-next.1

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.3.0-next.1
  - @backstage/plugin-events-node@0.2.1-next.1
  - @backstage/config@1.0.6-next.0

## 0.1.2-next.0

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.2.1-next.0
  - @backstage/config@1.0.6-next.0
  - @backstage/plugin-events-node@0.2.1-next.0

## 0.1.1

### Patch Changes

- 884d749b14: Refactored to use `coreServices` from `@backstage/backend-plugin-api`.
- 0f46ec304c: Add `createGithubSignatureValidator(config)` which can be used
  to create a validator used at an ingress for topic `github`.

  On top, there is a new `githubWebhookEventsModule` for the new backend plugin API
  which auto-registers the `HttpPostIngress` for topic `github` incl. the validator.

  Please find more information at
  https://github.com/backstage/backstage/tree/master/plugins/events-backend-module-github/README.md.

- Updated dependencies
  - @backstage/backend-plugin-api@0.2.0
  - @backstage/plugin-events-node@0.2.0
  - @backstage/config@1.0.5

## 0.1.1-next.3

### Patch Changes

- Updated dependencies
  - @backstage/backend-plugin-api@0.2.0-next.3
  - @backstage/config@1.0.5-next.1
  - @backstage/plugin-events-node@0.2.0-next.3

## 0.1.1-next.2

### Patch Changes

- 884d749b14: Refactored to use `coreServices` from `@backstage/backend-plugin-api`.
- Updated dependencies
  - @backstage/backend-plugin-api@0.2.0-next.2
  - @backstage/config@1.0.5-next.1
  - @backstage/plugin-events-node@0.2.0-next.2

## 0.1.1-next.1

### Patch Changes

- 0f46ec304c: Add `createGithubSignatureValidator(config)` which can be used
  to create a validator used at an ingress for topic `github`.

  On top, there is a new `githubWebhookEventsModule` for the new backend plugin API
  which auto-registers the `HttpPostIngress` for topic `github` incl. the validator.

  Please find more information at
  https://github.com/backstage/backstage/tree/master/plugins/events-backend-module-github/README.md.

- Updated dependencies
  - @backstage/backend-plugin-api@0.1.5-next.1
  - @backstage/config@1.0.5-next.1
  - @backstage/plugin-events-node@0.2.0-next.1

## 0.1.1-next.0

### Patch Changes

- Updated dependencies
  - @backstage/plugin-events-node@0.2.0-next.0
  - @backstage/backend-plugin-api@0.1.5-next.0

## 0.1.0

### Minor Changes

- b3a4edb885: Adds a new module `github` to plugin-events-backend.

  The module adds a new event router `GithubEventRouter`.

  The event router will re-publish events received at topic `github`
  under a more specific topic depending on their `x-github-event` value
  (e.g., `github.push`).

  Please find more information at
  https://github.com/backstage/backstage/tree/master/plugins/events-backend-module-github/README.md.

### Patch Changes

- Updated dependencies
  - @backstage/plugin-events-node@0.1.0
  - @backstage/backend-plugin-api@0.1.4
